require 'pgplot'

local device = 'contour.png/PNG'
assert(pgplot.start(device) > 0, 'can\'t initialize device')
--assert(pgplot.start('cont.ps/CPS') > 0, 'can\'t initialize device')
pgplot.ask(true)
-- set color
pgplot.setcolorbyname(0, 'white')
pgplot.setcolorbyname(1, 'black')
-- compute function
local nx = 40
local ny = 40
local f = {}
local fmin = 0
local fmax = 0
for i = 1, nx do
	f[i] = {}
	for j = 1, ny do
		local x = math.cos(0.3*math.sqrt(i*2)-0.13333*j)*math.cos(0.13333*i)
				+ (i-j)/nx
		fmin = math.min(x, fmin)
		fmax = math.max(x, fmax)
		f[i][j] = x
	end
end
-- compute red-green palette
local rgpal = pgplot.genpalette(0, 1, 0, 1, 0, 0)
-- draw image and contours
levels = {}
for i = 1, 20 do
	levels[i] = fmin + i * (fmax - fmin) / 20
end
pgplot.image(f, rgpal)
pgplot.label('', '', 'Image and contour')
pgplot.setcharheight(0.75)
pgplot.contour(f, levels, true, true) -- contour on same plot
pgplot.finish()
